﻿using System;
namespace SumAfterMinimum
{
    public class Program
    {
        /// <summary>
        /// Метод, запрашивающий у пользователя размерность рассива
        /// </summary>
        /// <returns></returns>
        static int EnteringCountOfArrayElements()
        {
            Console.Write("Введите количество элементов массива (2-20): "); int countOfArrayElements = Convert.ToInt32(Console.ReadLine());
            while (true) //бесконечный цикл на ввод данных с клавиатуры
            {
                if (countOfArrayElements < 2 || countOfArrayElements > 20) //условие на размерность массива
                {
                    Console.Write("Введите количество элементов от 2 до 20: "); countOfArrayElements = Convert.ToInt32(Console.ReadLine());
                }
                else
                {
                    break; //завершение ццикла, если введенное число соответсвует требованиям
                }
            }
            return countOfArrayElements;
        }
        /// <summary>
        /// Метод, запрашивающий у пользователя значения каждого элемента массива 
        /// </summary>
        /// <param name="countOfArrayElements"></param>
        /// <returns></returns>
        static int[] EnteringArrayElements(int countOfArrayElements)
        {
            int[] array = new int[countOfArrayElements]; for (int index = 0; index < array.Length; index++)
            {
                Console.Write("Введите {0} элемент массива: ", index + 1);
                if (!int.TryParse(Console.ReadLine(), out array[index]))//проверка на то, что знаечние не пустое и соответсвует типу данных
                {
                    Console.WriteLine("Неверный формат числа.");
                    index--;//повтор ввода элемента с тем же индексом, если введенное значение не прошло проверку
                    continue;
                }
            }
            return array;
        }
        /// <summary>
        /// Метод, выводящий массив на экран
        /// </summary>
        /// <param name="array"></param>
        static void OutputArray(int[] array)
        {
            foreach (int item in array)
            {
                Console.Write("{0} ", item);//вывод индекса и значения элемента массива
            }
        }
        /// <summary>
        /// Метод, реализующий поиск элемента массива с минимальным значением линейным методом
        /// </summary>
        /// <param name="array"></param>
        /// <returns></returns>
        static int FindingMinimumElement(int[] array)
        {
            int minimumElement = array[0];
            for (int index = 0; index < array.Length; index++)
            {
                if (array[index] < minimumElement)
                {
                    minimumElement = array[index];
                }
            }
            return minimumElement;
        }
        /// <summary>
        /// Метод, реализующий поиск индекса элемента массива с минимальным значением линейным методом
        /// </summary>
        /// <param name="array"></param>
        /// <returns></returns>
        static int FindingIndexMinimumElement(int[] array)
        {
            int indexMinimumElement = 0;
            for (int index = 0; index < array.Length; index++)
            {
                if (array[index] < array[indexMinimumElement])
                {
                    indexMinimumElement = index;
                }
            }
            return indexMinimumElement;
        }
        /// <summary>
        /// Метод, реализующий подсчет количества элементов массива с минимальным значением
        /// </summary>
        /// <param name="array"></param>
        /// <param name="minimumElement"></param>
        /// <returns></returns>


        static int CountOfMinimum(int[] array, int minimumElement)
        {
            int countOfMinimumElement = 0;
            for (int index = 0; index < array.Length; index++)
            {
                if (array[index] == minimumElement)
                {
                    countOfMinimumElement++;
                }
            }
            return countOfMinimumElement;
        }
        /// <summary>
        /// Метод, реализующий подсчет искомой суммы 
        /// </summary>
        /// <param name="array"></param>
        /// <param name="indexMinimumElement"></param>
        /// <returns></returns>
        public static double FindingSum(int[] array, int indexMinimumElement)
        {
            double sum = 0;
            for (int i = ++indexMinimumElement; i < array.Length; i++)
            {
                sum += array[i];
            }
            return sum;
        }
        static void Main()
        {
            OutputArray(EnteringArrayElements(EnteringCountOfArrayElements()));//инициализоция и создание массива

            if (CountOfMinimum(EnteringArrayElements(EnteringCountOfArrayElements()), FindingMinimumElement(EnteringArrayElements(EnteringCountOfArrayElements()))) > 1)//проверка, если количество минимальных элементов больше 1
            {
                Console.WriteLine("\nВ массиве несколько минимальных элементов {0}", CountOfMinimum(EnteringArrayElements(EnteringCountOfArrayElements()), FindingMinimumElement(EnteringArrayElements(EnteringCountOfArrayElements()))));
            }
            else
            {
                Console.Write("\nСумма элементов массива после минимального: {1}", FindingSum(EnteringArrayElements(EnteringCountOfArrayElements()), FindingIndexMinimumElement(EnteringArrayElements(EnteringCountOfArrayElements()))));
            }
        }
    }
}
    